function fxDTSBrick::setSwitch(%obj, %switchVal, %client)
{
	%db = %obj.getDatablock();
	if (!%db.isTrainTrack)
	{
		return;
	}

	if (%switchVal > 2)
	{
		//determine current state
		for (%i = 2; %i >= 0; %i--)
		{
			if (%db == %db.switchBrick[%i].getID())
			{
				break;
			}
		}

		//cycle based on CCW/CW
		if (%switchVal % 2)
		{
			%switchVal = (%i + 1) % 3;
			%direction = "CW";
		}
		else
		{
			%switchVal = (%i + 2) % 3; //have to add since negative number mods aren't always correct in torque
			%direction = "CCW";
		}
	}

	if (%switchVal < 3)
	{
		%newDB = %db.switchBrick[%switchVal];
		if (!isObject(%newDB) || %db == %newDB.getID())
		{
			return;
		}
		else
		{
			%obj.setDatablock(%newDB);

			if(%db.noBrickSounds)
			{
				return;
			}
			else
			{
				%obj.playSound("BrickChangeSound");
			}

			switch (%switchVal)
			{
				case 0: %obj.onSwitchSetLeft(%client);
				case 1: %obj.onSwitchSetStraight(%client);
				case 2: %obj.onSwitchSetRight(%client);
			}
		}
	}
}

registerOutputEvent( "fxDTSBrick", "setSwitch", "list Left 0 Straight 1 Right 2 ToggleCW 3 ToggleCCW 4", 1 );


////////////////////


function fxDTSBrick::onSwitchSetLeft(%obj, %client)
{
	%data = %obj.getDataBlock();
	
	// add a delay so people can't do loops
	if( %obj.onSwitchSetLeftDelay > getSimTime() )
		return;
		
	%obj.onSwitchSetLeftDelay = getSimTime() + 33;

	$InputTarget_["Self"]   = %obj;
	$InputTarget_["Player"] = %client.player;
	$InputTarget_["Client"] = %client;
	$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj);

	%obj.processInputEvent("onSwitchSetLeft", %client);
}

registerInputEvent( "fxDTSBrick", "onSwitchSetLeft", "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection");


function fxDTSBrick::onSwitchSetStraight(%obj, %client)
{
	%data = %obj.getDataBlock();
	
	// add a delay so people can't do loops
	if( %obj.onSwitchSetStraightDelay > getSimTime() )
		return;
		
	%obj.onSwitchSetStraightDelay = getSimTime() + 33;

	$InputTarget_["Self"]   = %obj;
	$InputTarget_["Player"] = %client.player;
	$InputTarget_["Client"] = %client;
	$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj);

	%obj.processInputEvent("onSwitchSetStraight", %client);
}

registerInputEvent( "fxDTSBrick", "onSwitchSetStraight", "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection");


function fxDTSBrick::onSwitchSetRight(%obj, %client)
{
	%data = %obj.getDataBlock();
	
	// add a delay so people can't do loops
	if( %obj.onSwitchSetRightDelay > getSimTime() )
		return;
		
	%obj.onSwitchSetRightDelay = getSimTime() + 33;

	$InputTarget_["Self"]   = %obj;
	$InputTarget_["Player"] = %client.player;
	$InputTarget_["Client"] = %client;
	$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj);

	%obj.processInputEvent("onSwitchSetRight", %client);
}

registerInputEvent( "fxDTSBrick", "onSwitchSetRight", "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection");

function Vehicle::setTrain(%vehicle, %setting, %client)
{
	if (%setting && !isEventPending(%vehicle.trainLoopSchedule))
	{
		trainLockLoop(%vehicle);
	}
	else if (!%setting)
	{
		cancel(%vehicle.trainLockLoop);
	}
}

registerOutputEvent(Vehicle, "setTrain","list On 1 Off 0", 1);


////////////////////


function fxDTSBrick::onTrainEnterTrack(%obj, %train)
{
	// add a delay so people can't do loops
	if( %obj.onTrainEnterTrackDelay > getSimTime() )
		return;
		
	%obj.onTrainEnterTrackDelay = getSimTime() + 33;

	$InputTarget_["Self"]   = %obj;
	$InputTarget_["Driver"] = %train.getControllingObject();
	$InputTarget_["Client"] = %train.getControllingObject().client;
	$InputTarget_["Vehicle"] = %train;
	$InputTarget_["Minigame"] = getMiniGameFromObject(%obj);

	%obj.processInputEvent("onTrainEnterTrack", %client);
}

registerInputEvent( "fxDTSBrick", "onTrainEnterTrack", "Self fxDTSBrick\tDriver(Bot) Bot\tClient GameConnection\tMinigame Minigame\tVehicle Vehicle");

function fxDTSBrick::onTrainLeaveTrack(%obj, %train)
{
	// add a delay so people can't do loops
	if( %obj.onTrainEnterTrackDelay > getSimTime() )
		return;
		
	%obj.onTrainEnterTrackDelay = getSimTime() + 33;

	$InputTarget_["Self"]   = %obj;
	$InputTarget_["Driver(Bot)"] = %train.getControllingObject();
	$InputTarget_["Client"] = %train.getControllingObject().client;
	$InputTarget_["Vehicle"] = %train;
	$InputTarget_["Minigame"] = getMiniGameFromObject(%obj);

	%obj.processInputEvent("onTrainLeaveTrack", %client);
}

registerInputEvent( "fxDTSBrick", "onTrainLeaveTrack", "Self fxDTSBrick\tDriver(Bot) Bot\tClient GameConnection\tMinigame Minigame\tVehicle Vehicle");

function AIPlayer::setForwardMovement(%obj, %val)
{
	%obj.setMoveY(%val);
}

registerOutputEvent( "Bot", "setForwardMovement", "float -1 1 0.1 0" );

function AIPlayer::setBraking(%obj, %val)
{
	if (!isObject(%obj.getObjectMount()))
		return;

	%obj.setJumping(%val);
}

registerOutputEvent( "Bot", "setBraking", "bool" );